var querystring = require("querystring");

module.exports = function(app, mongoClient, mongoDBuri){

app.post('/testDoctor', function(req, res){
        console.log("testDoctor");
        res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});
        var findReqToString = querystring.stringify(req.body);
        console.log("result: "+findReqToString);
        res.write(JSON.stringify(findReqToString));
        res.end();
});

app.post('/doctorregistrationcheak', function(req, res){
    console.log("doctorregistrationcheak requested");
    res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
    var doctor_iD = querystring.parse(findReqToString).doctorid;
    var doctor_name = querystring.parse(findReqToString).doctorname;

    var collection_name = "DoctorInfo";
    var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At DoctorInfo collection.");

                        collection.find({DoctorID:doctor_iD, Name:doctor_name}).toArray(function(err,records){
                            res.write(JSON.stringify(records));
                            res.end();
                            console.log(records.length);
                        });
                }
        });
});

app.post('/doctorregistrationinsert', function(req, res) {
    var collection_name = "DoctorInfo";
    var collection;
    mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At DoctorInfo collection.");

                        collection.insert(req.body, function (err, result) {
                              if (err) {
                                    console.log(err);
                              } else {
                                    console.log('Inserted %d documents into the "DoctorInfo" collection.');
                                    res.end();
                              }    
                              db.close();
                        });
                }
     });
});

//Doctor login check in match ID and password
app.post('/doctorLogincheak', function(req, res) {
    console.log("Doctor login check requested.");
    res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
    var doctor_iD = querystring.parse(findReqToString).doctorid;
    var doctor_password = querystring.parse(findReqToString).doctorpassword;

    var collection_name = "DoctorInfo";
    var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At PatientInfo collection.");

            //query collection "first_name"_"last_name" for all docs between start and finish
            collection.find({DoctorID:doctor_iD, Password:doctor_password}).toArray(function(err,records){
                res.write(JSON.stringify(records));
                res.end();
                console.log(records.length);
            });

                }
        });
});


app.post('/commentinsert', function(req, res){
    console.log("comment insert");
    var collection_name = "Comment";
    var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At comment collection.");

                    collection.insert(req.body, function (err, result) {
                      if (err) {
                        console.log(err);
                      } else {
                        console.log('Inserted %d documents into the "Comment" collection.');
                        res.end(); 
                        }
              //Close connection
              db.close();
                });
                }
        });

});


//patientdoctorcommentretrieve
app.post('/patientdoctorcommentretrieve', function(req, res) {
    console.log("patientdoctorcommentretrieve requested.");
    res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
    var doctor_ID = querystring.parse(findReqToString).doctorID;
    var patient_iD = querystring.parse(findReqToString).patientid;

    var collection_name = "Comment";
    var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At Comment collection.");

                        collection.find({DoctorID:doctor_ID, PatientID:patient_iD}).toArray(function(err,records){
                           if(err){
                            res.writeHead(200,{"Content-Type":"text/plain"});
                            res.write("data retrieve failed.");
                            res.end();
                               
                           }
                           res.write(JSON.stringify(records));
                           res.end();
                           console.log(records.length);
                         });
                }
        });
});


//doctorcommentretrieve
app.post('/doctorcommentretrieve', function(req, res) {
    console.log("doctorcommentretrieve requested.");
    res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
    var doctor_ID = querystring.parse(findReqToString).doctorID;

    var collection_name = "Comment";
    var collection;

        mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At Comment collection.");

                        collection.find({DoctorID:doctor_ID}).toArray(function(err,records){
                           res.write(JSON.stringify(records));
                           res.end();
                           console.log(records.length);
                         });
                }
        });
});





};
