var querystring = require("querystring");
var SerialPort = require('serialport');
var Readline = SerialPort.parsers.Readline;

//configure serial port:
var port = new SerialPort('/dev/cu.usbmodem1421', {
   baudrate: 115200
});

var portOpen = 0;
port.on('open', function(){
        console.log("open");
	portOpen = 1;
});

var parser = port.pipe(Readline({delimiter: '\r\n'}));

parser.on('data', function(data){
        console.log(data);
});


module.exports = function(app, mongoClient, mongoDBuri) {
	app.post('/toSerialPort', function (req, res) {
	   var reqToString = querystring.stringify(req.body);
	   console.log("toSerialPort data: " + reqToString);
	   if(portOpen == 1){
	      port.write(reqToString);
	      res.write('Serialport command executed');
	   }
	   else {
	      res.write('serial port not open');
	   }
	   res.end();
	});
}
