var querystring = require("querystring");


module.exports = function(app, mongoClient, mongoDBuri){
/* This is example for middleware functions with MongoDB lookup/insert operations

//mongoDB data lookup example
app.post('/datalookup', function(req, res){
    console.log("data look up requested");
    res.writeHead(200, {"Content-Type": "text/plain","Access-Control-Allow-Origin":"*"});

    var findReqToString = querystring.stringify(req.body);
    var lookUpData = querystring.parse(findReqToString).lookUpDataReq;

    var collection_name = "exampleCollection";
    var collection;

    mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        collection = db.collection(collection_name);
                        console.log("At " + collection_name + " collection");
                        collection.find({exampleField:lookUpData}).toArray(function(err,records){
                            res.write(JSON.stringify(records));
                            res.end();
                            console.log(records.length);
                        });
                }
        });
});


//mongoDB data insert
app.post('/datainsert', function(req, res) {
    console.log("data insert requested");


    var collection_name = "exampleCollection";
    var collection;

    mongoClient.connect(mongoDBuri, function(err,database){
                if(err){
                        console.log("Error connecting to db");
                        res.writeHead(200,{"Content-Type":"text/plain"});
                        res.write("DB connection failed.");
                        res.end();
                } else {
                        var db = database;
                        console.log("Connected to db");
                        collection = db.collection(collection_name);
                        console.log("At " + collection_name + " collection");

                        collection.insert(req.body, function (err, result) {
                              if (err) {
                                    console.log(err);
                              } else {
                                    console.log('Inserted ' + req.body + ' into the '+collection_name+' collection.');
                                    res.end();
                              }
                              db.close();
                        });
                }
     });
});

*/

};
